pkg_delete(1)

NAME
pkg_delete - a utility for deleting previously installed software package distributions.

SYNOPSIS
pkg_delete [-vDdnf] [-p prefix] pkg-name ...

DESCRIPTION
The pkg_delete command is used to delete packages that have been previously installed with the pkg_add(1) command.

WARNING
Since the pkg_delete command may execute scripts or programs provided by a package file, your system may be susceptible to ``trojan horses'' or other subtle attacks from miscreants who create dangerous package files.

You are advised to verify the competence and identity of those who provide installable package files. For extra protection, examine all the package control files in the package record directory ( /var/db/pkg/<pkg-name>/ ). Pay particular attention to any +INSTALL, +DEINSTALL, +REQUIRE or +MTREE_DIRS files, and inspect the +CONTENTS file for @cwd, @mode (check for setuid), @dirrm, @exec, and @unexec directives, and/or use the pkg_info(1) command to examine the installed package control files.

OPTIONS
The following command line options are supported.

pkg-name ...
    The named packages are deinstalled.

-v  Turns on verbose output. Optional.

-D  If a deinstallation script exists for a given package, do not execute it. Optional.

-n  Don't actually deinstall a package, just report the steps that would be taken if it were. Optional.

-p prefix
    Sets prefix as the directory in which to delete files from any installed packages which do not explicitly set theirs. For most packages, the prefix will be set automatically to the installed location by pkg_add(1). Optional.

-d  Remove empty directories created by file cleanup. By default, only files/directories explicitly listed in a package's contents (either as normal files/directories or with the @dirrm directive) will be removed at deinstallation time. This option tells pkg_delete to also remove any directories that were emptied as a result of removing the package. Optional.

-f  Force removal of the package, even if a dependency is recorded or the deinstall or require script fails. Optional.

TECHNICAL DETAILS
pkg_delete does pretty much what it says. It examines installed package records in /var/db/pkg/<pkg-name>, deletes the package contents, and finally removes the package records.

If a package is required by other installed packages, pkg_delete will list those dependent packages and refuse to delete the package (unless the -f option is given).

If the package contains a require file (see pkg_create(1) ), then this is executed first as
require <pkg-name> DEINSTALL

(where pkg-name is the name of the package in question and is a keyword denoting that this is a deinstallation) to see whether or not deinstallation should continue. A non-zero exit status means no, unless the -f option is specified.

If a deinstall script exists for the package, it is executed before any files are removed. It is this script's responsibility to clean up any additional messy details around the package's installation, since all pkg_delete knows how to do is delete the files created in the original distribution. The deinstall script is called as:
deinstall <pkg-name> DEINSTALL

Passing the keyword DEINSTALL lets you potentially write only one program/script that handles all aspects of installation and deletion.

All scripts are called with the environment variable PKG_PREFIX set to the installation prefix (see the -p option above). This allows a package author to write a script that reliably performs some action on the directory where the package is installed, even if the user might have changed it by specifying the -p option when running pkg_delete or pkg_add.

SEE ALSO
pkg_add(1), pkg_create(1), pkg_info(1), mktemp(3), mtree(8).

AUTHORS
Jordan Hubbard
    most of the work
John Kohl
    refined it for NetBSD

BUGS
Sure to be some.